﻿using MVCAndKnockout.Business.Models;
using System;
using System.Collections.Generic;
using MVCAndKnockout.Common;

namespace MVCAndKnockout.Business.Services
{
    public interface IContactManagementService : IDisposable
    {
        IEnumerable<ContactType> GetContactTypes(ICriteria criteria);

        IEnumerable<ContactType> GetAllContactTypes();

        int GetTotalContactTypes();

        IOperationResult<ContactType> CreateContactType(ContactType contactType);

        IOperationResult<ContactType> GetContactType(int id);

        IOperationResult<ContactType> UpdateContactType(ContactType contactType);

        IOperationResult<ContactType> DeleteContactType(ContactType contactType);


        IEnumerable<ContactInfo> GetContacts(ICriteria criteria);

        int GetTotalContacts();

        IOperationResult<Contact> CreateContact(Contact contact);

        IOperationResult<Contact> GetContact(int id);

        IOperationResult<Contact> UpdateContact(Contact contact);

        IOperationResult<Contact> DeleteContact(Contact contact);
    }
}
