﻿namespace MVCAndKnockout.Business.Services
{
    /// <summary>
    /// Results of an operation, such as Update or Insert
    /// </summary>
    public interface IOperationResult<T>
        where T: class 
    {

        T Result { get; }

        string ValidationError { get; }

        string ConcurrencyError { get; }

        string UnhandledError { get; }

        bool Success { get; }

    }
}