﻿

namespace MVCAndKnockout.Business.Services
{
    public class OperationResult<T> : IOperationResult<T>
        where T : class, new()
    {

        public OperationResult(T operationObject, string validationErrors, bool concurrencyError, bool unhandledError)
        {
            Result = operationObject;
            ValidationError = validationErrors;
            ConcurrencyError = concurrencyError ? "Another user changed your data" : "";
            UnhandledError = unhandledError ? "Unexpected error has occurred" : "";
        }

        public T Result { get; internal set; }

        public string ValidationError { get; internal set; }

        public string ConcurrencyError { get; internal set; }

        public string UnhandledError { get; internal set; }

        public bool Success
        {
            get
            {
                return string.IsNullOrEmpty(ValidationError) && string.IsNullOrEmpty(ConcurrencyError) &&
                       string.IsNullOrEmpty(UnhandledError);
            }
        }

    }
}
