﻿using MVCAndKnockout.Data;
using System.Data.Entity;
using MVCAndKnockout.DataAccess.Config;

namespace MVCAndKnockout.DataAccess
{
    public class Context : DbContext
    {
        public Context()
            :base("Name=ContactsDb")
        {
            
        }

        public DbSet<Company> Companies { get; set; }

        public DbSet<Contact> Contacts { get; set; }

        public DbSet<ContactType> ContactTypes { get; set; }

        protected override void OnModelCreating(DbModelBuilder modelBuilder)
        {
            modelBuilder.Configurations.Add(new AddressConfig());
            modelBuilder.Configurations.Add(new ContactConfig());
            modelBuilder.Configurations.Add(new CompanyConfig());
            modelBuilder.Configurations.Add(new ContactTypeConfig());
        }
    }
}
