﻿using System.Collections.Generic;
using MVCAndKnockout.Common;
using MVCAndKnockout.Data;
using MVCAndKnockout.DataAccess.Repository.Core;

namespace MVCAndKnockout.DataAccess.Repository
{
    public interface IContactManagementRepository : IWriteRepository
    {
        IEnumerable<ContactType> GetContactTypes(ICriteria criteria);

        IEnumerable<ContactInfo> GetContacts(ICriteria criteria);

        int GetTotalContactTypes();

        ContactType GetContactType(int id);
        
        Contact GetContact(int id);

        int GetTotalContacts();

        IEnumerable<ContactType> GetAllContactTypes();
    }
}
