﻿using System;
using System.Collections.Generic;
using System.Linq.Expressions;
using System.Text;
using System.Web.Mvc;

namespace MVCAndKnockout.Controllers
{
    public class ControllerBase : Controller
    {
        protected SelectList CreateSelectList<T>(
            IEnumerable<T> list,
            int selctedValue,
            Expression<Func<T, int>> idField,
            Expression<Func<T, string>> descriptionField)
        {
            var idProp = ((MemberExpression) idField.Body).Member.Name;
            var idescProp = ((MemberExpression)descriptionField.Body).Member.Name;
            var returnValue = new SelectList(list, idProp, idescProp, selctedValue);
            return returnValue;
        }

        protected string GetValidationErrors()
        {
            var errors = new StringBuilder();
            foreach (var field in ModelState.Values)
            {
                if (field.Errors.Count > 0)
                {
                    foreach (var error in field.Errors)
                    {
                        if (!errors.ToString().Contains(error.ErrorMessage))
                        {
                            errors.AppendLine(error.ErrorMessage);
                        }
                    }
                }
            }
            return errors.ToString();
        }
    }
}